
/*
 cc -g -c imvqevent.c
*/

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>


#include "../s_tools/smem.h"


#include "../as/asevent.h"


/* ------------------------------- AsevenT --------------------------- */


int Asevent_new(event,command,connection,username,flag)
struct AsevenT **event;
char *command;
int connection;
char *username;
int flag;
/*
 bit0= mark as control event
*/
{
 struct AsevenT *e;
 struct timezone tz;

 *event= e= TSOB_FELD(struct AsevenT,1);
 if(e==NULL)
   return(-1);
 e->command= NULL;
 e->type= (flag&1);
 e->connection= connection;
 e->username= NULL;
 gettimeofday(&(e->date),&tz);
 e->prev= NULL;
 e->next= NULL;
 if(Sregex_string(&(e->command),command,0)<=0)
   goto failed;
 if(Sregex_string(&(e->username),username,0)<=0)
   goto failed;
 return(1);
failed:;
 Asevent_destroy(event,0);
 return(-1);
}


int Asevent_destroy(event,flag)
struct AsevenT **event;
int flag;
/*
 bit0= adjust neighbor links
*/
{
 if(*event==NULL)
   return(0);
 if(flag&1){
   if((*event)->prev!=NULL)
     (*event)->prev->next= (*event)->next;
   if((*event)->next!=NULL)
     (*event)->next->prev= (*event)->prev;
 }
 Sregex_string(&((*event)->command),NULL,0);
 Sregex_string(&((*event)->username),NULL,0);
 Smem_freE((char *) (*event));
 *event= NULL;
 return(1);
}


int Asevent_get_cmd(event,cmd,flag)
struct AsevenT *event;
char **cmd;
int flag;
{
 int ret;
 char *cpt;

 /* ??? obsolete ??? : for compatibility with old prog : skip ^ to : */
 cpt= event->command;
 if(cpt[0]=='^') {
   cpt= strchr(cpt,':');
   if(cpt==NULL)
     cpt= event->command+strlen(event->command);
   else
     cpt++;
 }
 ret= Sregex_string(cmd,cpt,0);
 return(ret);
}


int Asevent_set_cmd(event,cmd,flag)
struct AsevenT *event;
char *cmd;
int flag;
{
 if(Sregex_string(&(event->command),cmd,0)<=0)
   return(-1);
 return(1);
}


int Asevent_get_username(event,username,flag)
struct AsevenT *event;
char **username;
int flag;
{
 int ret;
 
 if(event->username==NULL)
   ret= Sregex_string(username,"external_anonymous",0);
 else
   ret= Sregex_string(username,event->username,0);
 return(ret);
}


int Asevent_copy(source,target,flag)
struct AsevenT *source,*target;
int flag;
/*
 bit0= also copy linkage
*/
{
 int ret;

 if(Sregex_string(&(target->command),source->command,0)<=0)
   return(-1);
 target->type= source->type;
 if(Sregex_string(&(target->username),source->username,0)<=0)
   return(-1);
 target->date= source->date;
 if(flag&1) {
   target->next= source->next;
   target->prev= source->prev;
 }
 return(1);
}


