
/*
 cc -g -c sagent.c
*/

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>


#include "../as/asagent.h"

struct AsagenT *agent= NULL;


#include <signal.h>

void Cleanup_handler_pipe()
{
 return;
}


void Cleanup_handler_exit()
{
 alarm(0);
 Asagent_stderr(agent,"\n\nTIMEOUT ! Program aborted\n\n",1);
 Asagent_destroy(&agent,0);
 exit(4);
}


int Interpreter(agent,flag)
struct AsagenT *agent;
int flag;
{
 int ret;

 ret= Asagent_interpreter(agent,flag|1);
 return(ret);
}


#include "../http/sproxy.h"
#include "../http/httpproxy.h"
#include "../http/httprequest.h"

#include "../imv/imvapp.h"
#include "../imv/imvmapper.h"
#include "../imv/imvmover.h"
#include "../imv/imvfiles.h"
#include "../imv/imvguard.h"
#include "../imv/imvhistory.h"
#include "../as/asrm.h"


#include "../img/imgdb.h"
#include "../img/imgdbf.h"
#include "../img/imgdbs_mysql.h"
#include "../img/imgmap.h"
#include "../img/imgmatch.h"
#include "../img/imgcmp.h"
#include "../img/imgexempt.h"
#include "../img/imgsamp.h"
#include "../img/imgstd.h"
#include <jpeglib.h>
#include <jerror.h>
#include <setjmp.h>
#define Imgrgb_itselF 
#include "../img/imgrgb.h"

#include "../as/asagent.h"
#include "../as/asevent.h"
#include "../as/asinput.h"
#include "../as/asprog.h"
#include "../as/asqueue.h"
#include "../as/asview.h"

#include "../as/asvmsg.h"
#include "../as/asfrontend.h"

#include "../s_tools/saccess.h"
#include "../s_tools/sblowfish.h"
#include "../s_tools/sconn.h"
#include "../s_tools/sfile.h"
#include "../s_tools/smem.h"
#include "../s_tools/sregex.h"
#include "../s_tools/stcp.h"
#include "../s_tools/stunnel.h"


int print_sizes()
{
 printf("struct SproxY : %ld\n",sizeof(struct SproxY));
 printf("struct HttpproxY : %ld\n",sizeof(struct HttpproxY));
 printf("struct HttprequesT : %ld\n",sizeof(struct HttpproxY));
 printf("\n");
 printf("struct ImvapP : %ld\n",sizeof(struct ImvapP));
 printf("struct ImvfilE : %ld\n",sizeof(struct ImvfilE));
 printf("struct ImvfileS : %ld\n",sizeof(struct ImvfileS));
 printf("struct ImvlocatioN : %ld\n",sizeof(struct ImvlocatioN));
 printf("struct ImvguarD : %ld\n",sizeof(struct ImvguarD));
 printf("struct ImvhistorY : %ld\n",sizeof(struct ImvhistorY));
 printf("struct ImvmappeR : %ld\n",sizeof(struct ImvmappeR));
 printf("struct ImvmoveR : %ld\n",sizeof(struct ImvmoveR));
 printf("struct AsrM : %ld\n",sizeof(struct AsrM));
 printf("\n");
 printf("struct ImgcmP   : %ld\n",sizeof(struct ImgcmP));
 printf("struct ImgmaP   : %ld\n",sizeof(struct ImgmaP));
 printf("struct ImgmatcH : %ld\n",sizeof(struct ImgmatcH));
 printf("struct ImgdB    : %ld\n",sizeof(struct ImgdB));
 printf("struct ImgdbF   : %ld\n",sizeof(struct ImgdbF));
 printf("struct ImgdbS   : %ld\n",sizeof(struct ImgdbS));
 printf("struct ImgmapcachE : %ld\n",sizeof(struct ImgmapcachE));
 printf("struct ImgsamplE : %ld\n",sizeof(struct ImgsamplE));
 printf("struct ImgstD   : %ld\n",sizeof(struct ImgstD));
 printf("struct Imgrgb_error_handlE : %ld\n",
                                           sizeof(struct Imgrgb_error_handlE));
 printf("struct ImgrgB : %ld\n",sizeof(struct ImgrgB));
 printf("struct ImgexempT : %ld\n",sizeof(struct ImgexempT));
 printf("struct ImgexemptlisT : %ld\n",sizeof(struct ImgexemptlisT));
 printf("\n");
 printf("struct AsagenT : %ld\n",sizeof(struct AsagenT));
 printf("struct AsevenT : %ld\n",sizeof(struct AsevenT));
 printf("struct AsinconN : %ld\n",sizeof(struct AsinconN));
 printf("struct AsinpuT : %ld\n",sizeof(struct AsinpuT));
 printf("struct AsproG : %ld\n",sizeof(struct AsproG));
 printf("struct ImvstatemenT : %ld\n",sizeof(struct ImvstatemenT));
 printf("struct AsqueuE : %ld\n",sizeof(struct AsqueuE));
 printf("struct AsviewsubscR : %ld\n",sizeof(struct AsviewsubscR));
 printf("struct AsviewprotO : %ld\n",sizeof(struct AsviewprotO));
 printf("struct AsvieW : %ld\n",sizeof(struct AsvieW));
 printf("\n");
 printf("struct AsviewmsgfielD : %ld\n",sizeof(struct AsviewmsgfielD));
 printf("struct AsviewmsG : %ld\n",sizeof(struct AsviewmsG));
 printf("struct AsfrontenD : %ld\n",sizeof(struct AsviewmsG));
 printf("\n");
 printf("struct SaccessiteM : %ld\n",sizeof(struct SaccessiteM));
 printf("struct SaccesS : %ld\n",sizeof(struct SaccesS));
 printf("struct SconnfD : %ld\n",sizeof(struct SconnfD));
 printf("struct SconN : %ld\n",sizeof(struct SconN));
 printf("struct SblowfisH : %ld\n",sizeof(struct SblowfisH));
 printf("struct StunneL : %ld\n",sizeof(struct StunneL));
 printf("struct Sfile_popeN : %ld\n",sizeof(struct Sfile_popeN));
 printf("struct Sfile_linE : %ld\n",sizeof(struct Sfile_linE));
 printf("struct SregeX : %ld\n",sizeof(struct SregeX));
 printf("struct LstrinG : %ld\n",sizeof(struct LstrinG));
 printf("struct StcpconN : %ld\n",sizeof(struct StcpconN));
 printf("struct StcpserV : %ld\n",sizeof(struct StcpserV));
/*
 printf("struct  : %ld\n",sizeof(struct ));
*/
 return(1);
}


int Print_sconn(marker,sconn,flag)
char *marker;
struct SconN *sconn;
int flag;
{
 int ret,count;
 char buf[1024];

 if(flag&1) {
   printf("\n%s  Connection has been detached\n",marker);
   return(1);
 }

 ret= Sconn_read(sconn,buf,sizeof(buf)-1,&count,0);
 if(ret==0) {
   printf("\n%s  EOF detected\n",marker);
   return(0);
 }
 if(ret<=0)
   return(ret);
 if(ret==1 && count>0) {
   buf[count]= 0;
   printf("\n%s\n",marker);
   printf("%s",buf);
   printf("\n%s\n",marker);
 }
 return(ret);
}


int Interrupted(marker,sconn,flag)
char *marker;
struct SconN *sconn;
int flag;
{
 int ret,count;
 char buf[1024];

 if(flag&1) 
   printf("\n%s  Connection has been detached\n",marker);
 else 
   printf("\n%s  Data available or EOF\n",marker);
 return(1);
}


main(argc,argv)
int argc;
char **argv;
{
 int ret,ard= 1,i,j,count,portnumber;
 char *cpt,line[4096],buf[1024];
 struct AsevenT *event= NULL;
 struct SconN *sconn= NULL;

 /* full memory supervision */
 Smem_set_record_items(1);


 if(0) { 
   FILE *fp;
   char buf[1024],result[20];
   char *ctx= NULL;
   double byte_count;
   int mode= 1; /* 1=md5 , 2=sha1 */

   fp= fopen("/u/FERTIG/NBX","rb");
   if(fp==NULL)
     exit(1);
   ret= Shash(&ctx,buf,0,result,mode,1);
   if(ret<=0)
     exit(2);
   while(1) {
     ret= fread(buf,1,sizeof(buf),fp);
     if(ret<=0)
   break;
     byte_count+= ret;
     Shash(&ctx,buf,ret,result,mode,0);
   }
   fclose(fp);
   Shash(&ctx,buf,0,result,mode,2);
   for(i=0;i<16+4*(mode==2);i++)
     printf("%2.2x",(unsigned char) result[i]);
   printf("\n");
   exit(0);
 }

 print_sizes();
/*
 exit(0);
*/

 printf("Portnumber ?\n");
 scanf("%ld",&portnumber);

 /* <<< preliminary signal handling */
 signal(SIGPIPE,Cleanup_handler_pipe);
 signal(SIGALRM,Cleanup_handler_exit);

 ret= Asagent_new(&agent,argv[0],1,0);
 if(ret<=0) {
   fprintf(stderr,"%s : creation of agent object failed\n",argv[0]);
   exit(1);
 }

 ard= 1;
 ret= Asagent_read_options(agent,argc,argv,&ard,0);
 if(ret<=0) {
   ret= 2;
   goto ex;
 }
 if(ret==3)
   goto ok;


 /* ------- test area ------ */

 goto interrupting_inconn;


handled_inconn:;
 /* ----------- testing externally handled input connections -------------- */

 /* create TCP/IP SconN */
 ret= Sconn_tcpclient_new(&sconn,"localhost",portnumber,agent->access,0);
 if(ret<=0)
   {ret= 4; goto ex;}
 /* attach to agent as mode 6 connection */
 ret= Asagent_new_handled_inconn(agent,sconn,"---",Print_sconn,0);
 if(ret<=0)
   {ret= 5; goto ex;}
 ret= Sconn_try_tunnel(sconn,0);
 if(ret<=0)
   {ret= 6; goto ex;}
 strcpy(line,"-add_view:-:all:default\n");
 ret= Sconn_write(sconn,line,strlen(line),0);
 if(ret<=0)
   {ret= 8; goto ex;}
 ret= Asagent_loop(agent,1);
 if(ret<=0)
   {ret= 3; goto ex;}
 goto ok;


interrupting_inconn:;
 /* - testing event loop interruption by select events at certain AsinconN - */
 
 /* create TCP/IP SconN */
 ret= Sconn_tcpclient_new(&sconn,"localhost",portnumber,NULL,0);
 if(ret<=0)
   {ret= 4; goto ex;}
 /* attach to agent as mode 6 connection */
 ret= Asagent_new_interrupting_inconn(agent,sconn,"+++",Interrupted,0);
 if(ret<=0)
   {ret= 5; goto ex;}
 ret= Sconn_try_tunnel(sconn,0);
 if(ret<=0)
   {ret= 6; goto ex;}
 strcpy(line,"-add_view:-:all:default\n");
 ret= Sconn_write(sconn,line,strlen(line),0);
 if(ret<=0)
   {ret= 8; goto ex;}

 while(1) {
   ret= Asagent_loop(agent,1);
   if(ret<=0)
     {ret= 3; goto ex;}
   if(ret==3)
     goto ok;
   if(ret==5) {
     /* read data from SconN */;
     ret= Sconn_read(sconn,buf,sizeof(buf)-1,&count,0);
     if(ret==0) {
       printf("\n+++  EOF detected at data socket\n");
       Asagent_destroy_inconn(agent,sconn,0);
       goto ok;
     }
     if(ret<=0)
       {ret= 7; goto ex;}
     if(ret==1 && count>0) {
       buf[count]= 0;
       printf("+++\n%s\n+++\n",buf);
       fflush(stdout);
     }
   }
 }
 goto ok;


 /* ------------------------------------------------------------------ */

 /* to become more visible in top */
 cpt= (char *) malloc(1024*1024);
 for(i=0;i<1024*1024;i++)
   cpt[i]= 0;

 /* overload agent's interpreter by frontend which sets bit0 */
 Asagent_attach_app(agent,agent,Interpreter,NULL,NULL,NULL,NULL,0);

 agent->loop_return_on_idle= 1;
 ret= Asagent_loop(agent,1);
 if(ret<=0)
   goto ex;
 for(i=0;i<10000;i++) {
   if((i%1)==0)
     fprintf(stderr,"\r%ld  ",i);

   strcpy(line,"-noop");
   for(j=0;j<100;j++) {
/*
     sprintf(line,"%ld.%ld",i,j);
*/
     ret= Asagent_send_cmd(agent,line,1);
     if(ret<=0)
       goto ex;
     ret= Asagent_poll(agent,1);
     if(ret!=1)
       goto ex;
   }
/*
   for(j=0;j<100;j++) {
     event= NULL;
     ret= Asevent_new(&event,"-noop",-1,"internal_owner",0);
     if(ret<=0)
       goto ex;
     ret= Asqueue_append(agent->queue,&event,1);
     if(ret<=0)
       goto ex;
   }
   ret= Asagent_clientloop(agent,2|1);
   if(ret<=0)
     goto ex;
   if(ret!=1)
     goto ok;  
*/

 }


 agent->loop_return_on_idle= 0;
 fprintf(stderr,"----------- entering agent loop ------------ \n");
 ret= Asagent_loop(agent,1);
 if(ret<=0) {
   fprintf(stderr,"%s : event loop aborted\n",argv[0]);
   ret= 3;
   goto ex;
 }
 if(ret==3)
   goto ok;

ok:;
 ret= 0;
ex:
 Asagent_destroy(&agent,0);
 Sconn_destroy(&sconn,0);

 Smem_stderr(1|2);
 exit(ret);
}


