
/*
  cc -g -o httpheader.c
*/

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "../s_tools/smem.h"
#include "../s_tools/sfile.h"
#include "../s_tools/sregex.h"

#include "httpheader.h"


/* --------------------------  HttpheadeR  ----------------------- */


int Httpheader_new(objpt,flag)
struct HttpheadeR **objpt;
int flag;
{
 struct HttpheadeR *o;
 int ret,i;

 *objpt= o= TSOB_FELD(struct HttpheadeR,1);
 if(o==NULL)
   return(-1);

 o->line= NULL;
 o->is_complete= 0;
 o->prev= NULL;
 o->next= NULL;

 return(1);
failed:;
 Httpheader_destroy(objpt,0);
 return(-1);
}


int Httpheader_destroy(objpt,flag)
struct HttpheadeR **objpt;
int flag;
{
 struct HttpheadeR *o;

 o= *objpt;
 if(o==NULL)
   return(0);

 Sregex_string(&(o->line),NULL,0);
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;

 Smem_freE((char *) o);
 *objpt= NULL;
 return(1);
}


int Httpheader_destroy_all(objpt,flag)
struct HttpheadeR **objpt;
int flag;
{
 struct HttpheadeR *o,*n;

 o= *objpt;
 if(o==NULL)
   return(0);
 for(;o->prev!=NULL;o= o->prev);
 for(;o!=NULL;o= n) {
   n= o->next;
   Httpheader_destroy(&o,0);
 }
 *objpt= NULL;
 return(1);
}


int Httpheader_get_line(o,pt,flag)
struct HttpheadeR *o;
char **pt;
int flag;
{
 *pt= o->line;
 return(1);
}


int Httpheader_is_complete(o,flag)
struct HttpheadeR *o;
int flag;
{
 return(o->is_complete);
}


int Httpheader_get_prev(o,pt,flag)
struct HttpheadeR *o;
struct HttpheadeR **pt;
int flag;
{
 *pt= o->prev;
 return(1);
}


int Httpheader_get_next(o,pt,flag)
struct HttpheadeR *o;
struct HttpheadeR **pt;
int flag;
{
 *pt= o->next;
 return(1);
}


int Httpheader_link(o,link,flag)
struct HttpheadeR *o;
struct HttpheadeR *link;
int flag;
/*
  bit0= insert as link->prev rather than as link->next
*/
{
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;
 o->prev= o->next= NULL;
 if(link==NULL)
   return(1);
 if(flag&1) {
   o->next= link;
   o->prev= link->prev;
   if(o->prev!=NULL)
     o->prev->next= o;
   link->prev= o;
 } else {
   o->prev= link;
   o->next= link->next;
   if(o->next!=NULL)
     o->next->prev= o;
   link->next= o;
 }
 return(1);
}


int Httpheader_consume(o,data,datalen,read_pt,flag)
struct HttpheadeR *o;
char *data;
int datalen;
char **read_pt;
int flag;
{
 int i,l,rptlen;
 char *rpt,*lfpt;

 rpt= data;
 rptlen= datalen;

read_text:;
 lfpt= NULL;
 if(rptlen<=0)
   return(2);
 for(i=0;i<rptlen;i++) 
   if(rpt[i]=='\n') {
     lfpt= rpt+i;
 break;
   }
 if(lfpt!=NULL) {
   if(Sregex_string_cut(&(o->line),rpt,(lfpt-rpt)+1,1)<=0)
     return(-1);
   *read_pt= lfpt+1;
   l= strlen(o->line);
   if(l>=2)
     if(o->line[l-2]=='\r') {
       o->is_complete= 1;
       o->line[l-2]= 0;
       return(1);
     }
   rptlen-= (*read_pt-rpt);
   rpt= *read_pt;
   goto read_text;
 } 
 *read_pt= data+datalen;
 if(Sregex_string_cut(&(o->line),rpt,rptlen,1)<=0)
     return(-1);
 return(2);
}


int Httpheader_find_head(o,start_text,found,flag)
struct HttpheadeR *o;
char *start_text;
char **found; /* must point to NULL or freeable memory */
int flag;
{
 int ret;
 struct HttpheadeR *h;

 if(o==NULL)
   return(0);
 for(h=o;h->prev!=NULL; h= h->prev);
 for(;h!=NULL;h= h->next) {
   if(strncmp(h->line,start_text,strlen(start_text))==0) {
     if(Sregex_string(found,h->line+strlen(start_text),0)<=0)
       {ret= -1; goto ex;}
     ret= 1; goto ex;
   }
 }
 ret= 0;
ex:
 return(ret);
}

