

#ifndef Imgmap_includeD
#define Imgmap_includeD

#include "../s_tools/sfile.h"

#include "imgsamp.h"


#define Imgmap_with_matcheR


#define Imgmap_sample_sizE       Imgsamp_max_sizE

#define Imgmap_color_epS         4.0
#define Imgmap_bw_epS            1.0
#define Imgmap_color_max_misseS  4
#define Imgmap_bw_max_misseS     2
#define Imgmap_search_methoD     0


struct ImgmapcachE {
 int refcount;
 char mapname[SfileadrL];
 struct ImgsamplE *start_samp;
 struct ImgsamplE *last_samp;
};


struct ImgmaP {

 struct ImgcmP *icmp;

 char mapname[SfileadrL];
 struct ImgdB *imdb;

 int disabled;
 int guarding;

 int caching;            /* bit0= enabled ,  bit1= loaded */
 struct ImgmapcachE *cache;

 struct ImgexemptlisT *exemptlist;
 int use_exemptlist;

 struct ImgsamplE *searchsamp;
 int spoints;

#ifdef Imgmap_with_matcheR

 struct ImgmatcH *matcher;

#else /* Imgmap_with_matcheR */

 int search_method;  /* 0= color_diff  , 1= color_double_diff */
 double color_eps;
 double bw_eps;
 int color_max_misses;
 int bw_max_misses;

#endif /* ! Imgmap_with_matcheR */

 char errmsg[2*SfileadrL];
};



char *Imgmap_get_errmsg();


#endif /* ! Imgmap_includeD */


/*

 ImgmaP is an image comparison data base of standardized image file
 representations of type ImgsamplE.
 The ImgsamplE and the file names are stored in files or data base
 management systems but may also be held in a memory cache duringi
 runtime. 

functions:
  Imgmapcache...
  _new()             create new cache object
  _destroy()         destroy object

 Imgmap...
  _new()             create new object
  _set_mapname()     set name of current data base, eventually load cache
  _get_mapname()     get name of current data base and its particular files
  _reset_errmsg()    clear error message text
  _get_errmsg()      get error message text
  _record()          write filename and ImgsamplE to data base
  _del_back()        delete last ImgsamplE and filename
  _search_reset()    set search position to start of data base
  _search()          search for matching sample and return filename
  _search_adr()      search for matching sample and return sample + filename
  _search_filename() search for filename and return sample
  _rm_filename()     delete data base records according to filename
  _refresh_filename() recomputes sample of filename
  _lookup()          return sample according to filename
  _copy_all()        copy data base file contents into another data base
  _garbage_coll()    copy data base to new one and rename
  _load_cache()      read whole data base into cache
  _destroy()         close data base and destroy object
  
  _set_eps(()        set catch radius for color and b/w images
  _set_spoints()     set number of sample points
  _get_spoints()     get number of sample points

  _init()            initialize existing ImgmaP
  _deactivate()      close data base and destroy cache
  _copy()            copy ImgmaP content to another one
  _temp_sample()     create a ImgsamP object not connected to data base
  _fopen()           open particular data base file
  _write_nam()       write filename to data base
  _write_samp()      write ImgsamP data to data base
  _read_samp()       read ImgsamP data from data base
  _fclose()          close particular data base file
  _truncate()        make smaller a particular file
  _attach_cache()    attach existing cache object to ImgmaP
  _make_cache()      create new cache object and attach to ImgmaP
  _new_samp()        create new sample and append to cache
  _find_in_cache()   search ImgsamplE with given file adress within cache
  _delete_cache()    detach cache object from data base and destroy if idle

*/ 
