
#ifndef Asxv_includeD
#define Asxv_includeD Yes


/* 
  AsxV attaches client capabilities for the sagent protocol to the
  wellknown shareware program xv. There also need to be made some
  changes to the xv sourcecode.
  After these changes, Option -asxv controls wether xv shall
  connect to a sagent server (e.g. simv) and listen for image
  notifications :
    -asxv subscription hostname portnumber username
  where subscription may be "current_file" or "double_files"
  If username is empty or "-" then the connection is unencrypted.
  Any other user name causes encryption according to sagent helptext :
  "Appendix agent C : Authentication and Encryption".
*/


/* exernal references to xv */

extern int numnames;
extern char *namelist[];
extern Display *theDisp;
extern Window mainW;
extern unsigned int dispWIDE;

void deleteFromList();
void AddFNameToCtrlList();
void ChangedCtrlList();
int openPic();
void GetWindowPos();
void SetWindowPos();
void HideTextWindows();


struct AsxV {

 struct AsfrontenD *frontend;
 int got_any_reply;   /* 1= at least one  message from asagent was received */
 int reply_timeout;                /* seconds to wait for the first message */

 int double_files;           /* watching :  0=current_file , 1=double_files */
 char *servername;                           /* hostname for TCP connection */
 int portnumber;                                /* port number on that host */
 char *username;                       /* if not empty : encrypt connection */

 int current_idx;                      /* idx of last current_file received */

 int lazy_refresh;                  /* 1= only show images if frontend idle */
 int need_refresh;              /* 1= unshown list change with lazy_refresh */

 int hide_on_empty;        /* 1= make image most invisible if list is empty */ 

 int raise_window;             /* 1= raise image window after image display */
 int lower_window;          /* 1= lower image window when image is canceled */

 int auto_jpgb;                      /* 1= repair by -jpgb command on error */
 char *last_jpgb;                   /* file name of the last repair attempt */

 int standalone;         /* 1= pop up the original warning or error windows */
};


#endif /* ! Asxv_includeD */

