
/*
  cc -g -c nntpgroup.c
*/

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>


/* Macro  for creating arrays of objects */
#define TSOB_FELD(typ,anz) (typ *) malloc((anz)*sizeof(typ));

#include "nntpconn.h"
#include "nntpfiler.h"
#include "nntpgroup.h"

#include "../s_tools/sfile.h"


/* -------------------- Nntpgroup ------------------- */


int Nntpgroup_new(group,conn,name,flag)
struct NntpgrouP **group;
struct NntpconN *conn;
char *name; 
int flag;
/*
 bit0= do not read group information from server
*/
{
 struct NntpgrouP *g;
 *group= g= TSOB_FELD(struct NntpgrouP,1);
 if(g==NULL){
   conn->errn= errno;
   sprintf(conn->errmsg,
           "Error %d on creating internal group structure:\n%s",
           errno,strerror(errno));
   return(-1);
 }
 g->conn= conn;
 strcpy(g->name,name);
 g->first_msgno= 1;
 g->last_msgno= 0x7FFFFFFF;
 g->dir[0]= 0;
 g->read= 0;
 if(!(flag&1)){
   if(Nntpgroup_read(g,0)<=0){
     Nntpgroup_destroy(group,0);
     return(0);
   }
 }
 return(1);
}


int Nntpgroup_destroy(group,flag)
struct NntpgrouP **group;
int flag;
{
 if(*group==NULL)
   return(0);
 free((char *) *group);
 *group= NULL;
 return(1);
}


int Nntpgroup_set_dir(group,dir,flag)
struct NntpgrouP *group;
char *dir;
int flag;
{
 strcpy(group->dir,dir);
 return(1);
}


int Nntpgroup_read(group,flag)
struct NntpgrouP *group;
int flag;
{
 int ret,dummy,dummy2;
 char cmd[Nntpgroup_strmaX];
 struct NntpconN *conn;

 conn= group->conn;

 sprintf(cmd,"GROUP %s",group->name);
 ret= Nntpconn_transaction(conn,cmd,"",0,"",0);
 if(ret<=0)
   return(ret);
 if(conn->status_code!=211){
   conn->errn= -7;
   sprintf(conn->errmsg,"Cannot access group %s :\n%s",
                                group->name,conn->status_line);
   return(0);
 }
 sscanf(conn->status_line,"%ld %ld %ld %ld",&dummy,&dummy2,
                          &(group->first_msgno),&(group->last_msgno));
 fprintf(stderr,"GROUP %s : message range %ld - %ld\n",group->name,group->first_msgno,
                                             group->last_msgno);
 Nntpconn_set_groupname(conn,group->name,0);
 group->read= 1;
 return(1);
}


int Nntpgroup_chdir(group,flag)
struct NntpgrouP *group;
int flag;
{
 int ret;
 ret= Nntpfiler_chdir_primitive(group->dir,&(group->conn->errn),
                                group->conn->errmsg,0);
 return(ret);
}


