
#include "../s_tools/sfile.h"

#ifndef Nntpload_head_inludeD

struct NntploaD {

 /* boss */
 struct NntpclienT *boss;

 /* source */
 struct NntpconN *conn;
 int article_state; /* 0=unread , 1=HEAD , 2=BODY */

 struct NntpheaD *head;
 int head_extern;
 struct NntpsubheaD *subhead;
 int subhead_extern;
 int header_seen;
 double announced_size;

 /* Encoding */
 int allow_yenc;   /* if = 1 the command  yenc_decode  must be in the path */
 int encoding; /*  -1=unencoded
                    0=still undetermined
                    1= MIME 1.0
                       "Content-Type: multipart/mixed; boundary=..."
                       && "Content-Transfer-Encoding: base64"
                    2= uuencode
                       "begin [0-7][0-7][0-7] filename ... end"
                    3= enforce plain text coding
                    4= yencoded
                */
 int bin_tee; /*
                   -1= no tee with undecoded binary data
                    0= no decision up to now
                    1= watch out for beginning of binary data
                    2= tee complete message body
               */
 int show_tee_in_body; /* 0= only show link to tee file ,
                          1= show data , 2= temporarily disabled */
 int tee_with_cr; /* 1= do not remove CR from line end while teeing uuencode */
 int ync_tee; /*    0= suffix .tee   1= suffix ync.tee */
 int looks_like_yenc; /* -1= unknown , 0= no , 1= yes */

 int html;               /* generate HTML tags within messages and lists */
 int short_header;

 /* Externally attached filter for content oriented selection */
 struct NntpfilteR *filter;

 /* target */
 char dir[SfileadrL];
 int filename_auto;      /* generate message filename from message number */
 char filename[SfileadrL];
 mode_t bin_chmod;
 int  bin_count;
 char bin_name[SfileadrL];
 char tee_name[SfileadrL];
 FILE *tee_fp;
 int tee_temp_handle;

 /* >>> this is not working yet. multi_binary just triggers teeing */
 /* multipart binary files */
 int multi_binary;       /* 0= disabled , 1= enabled ,
                                          2= enabled for two digit pattern */
 int bin_parts;
 int current_bin_part;
 int background_1st_part;    /* 0=normal name , 1=pseudo collision, 2=omit */
};


/* These are formatters for sprintf(,,filename) . Use exactly one %s .*/
/* The result has to be a valid shell command expecting the coded data at
   standard input and writing the decoded results to filename . */

#define Nntpload_mime_decodeR      "mimencode -u > %s"
#define Nntpload_uuencode_decodeR  "uudecode -o %s"
#define Nntpload_yenc_decodeR      "syenc_decode -o %s"


/* subdirectory of message directory for storing binary files */
#define Nntpload_bindiR            "bin"


/* quite restrictive default, just in case the second umask() does not work */
#define Nntpload_access_rightS  (S_IRUSR|S_IWUSR)


/* Limits for bytes or lines (if byte_count is 0) of a tee'd article
   to be also shown in message body (see above show_tee_in_body) */
#define Nntpload_show_tee_byte_limiT 32768
#define Nntpload_show_tee_line_limiT   400


/* Maximum length for auto wrap around of header lines 
   eventually includes "\\\r\n" (so 80 allows 77 payload characters) */
#define Nntpload_max_line_length 80

/* Set this macro to value 4 in order to get the lines of the short
   short header wrapped like the lines of the long header */
#define Nntpload_wrap_short_headerS 0


#define Nntpload_head_inludeD YES

#endif /* ! Nntpload_head_inludeD */

