

#ifndef Sdb_oci_includeD
#define Sdb_oci_includeD


/* one disadvantage of types is that they need to know about everything */
#include "oci.h"


#define Sdb_oci_dbtypE "OCI"
#define Sdb_oci_typelisT ",OCI,"

#define Sdb_oci_reconnect_maxtrY 5

#define Sdb_oci_min_msg_sizE 1024



struct Sdb_ocI {

 char *hostname;
 char *username;
 char *password;
 char *dbname;

 OCIEnv *db;
 OCIError *errhp;
 OCISvcCtx *svchp;
 int initialized;
 int opened;

 int auto_commit;     /* wether to send COMMIT WORK automatically after each
                         INSERT, UPDATE, or DELETE statement */
 int fetch_mode;      /* How to fetch the result rows (preferrably)
                           0= all at once ( buffered )
                           1= one by one ( unbuffered )
                       */

 struct Sdb_oci_stQ  *stq;
 char *query_token;  /* a mark wether a query is open , catchable by smem */

 char *search_where;
 struct Sdb_oci_stQ *search_stq;
 char *search_token;

 char *message;         /* refers to storage[>=Sdb_oci_min_msg_sizE]
                           provided by application */
};


#endif /* ! Sdb_oci_includeD */


/*

 Sdb_ocI is an implementation of the SDB data base access API.
 This version uses the Oracle 8 database server via OCI.

 Sdb_oci_stQ represents a SQL statement and eventually its result.

*/ 
