
/*
  cc -g -o sfcrc.c
*/
/* ( generated by CgeN on  Thu, 06 Jun 2002 10:26:02 GMT ) */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "../s_tools/smem.h"
#include "../s_tools/sfile.h"
#include "../s_tools/sregex.h"

#include "sfcrc.h"


/* --------------------------  SfcrC  ----------------------- */


int Sfcrc_new(objpt,in_data,in_data_len,flag)
struct SfcrC **objpt;
char *in_data;
int in_data_len;
int flag;
/*
 bit1= mark as invalid (e.g. a header object for a list)
*/
{
 struct SfcrC *o;
 int ret,i;

 *objpt= o= TSOB_FELD(struct SfcrC,1);
 if(o==NULL)
   return(-1);

 o->name= NULL;
 o->style= -1*(flag&1);
 o->in_data= NULL;
 o->in_data_len= 0;
 o->size= 0;
 o->crc32= 0;
 o->prev= NULL;
 o->next= NULL;

 if(in_data_len>0) {
   o->in_data= TSOB_FELD(char,in_data_len);
   if(o->in_data==NULL)
     goto failed;
   for(i= 0;i<in_data_len;i++)
     o->in_data[i]= in_data[i];
   o->in_data_len= in_data_len;
 }

 return(1);
failed:;
 Sfcrc_destroy(objpt,0);
 return(-1);
}


int Sfcrc_destroy(objpt,flag)
struct SfcrC **objpt;
int flag;
{
 struct SfcrC *o;

 o= *objpt;
 if(o==NULL)
   return(0);

 Sregex_string(&(o->name),NULL,0);
 Sregex_string(&(o->in_data),NULL,0);
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;

 Smem_freE((char *) o);
 *objpt= NULL;
 return(1);
}


int Sfcrc_destroy_all(objpt,flag)
struct SfcrC **objpt;
int flag;
{
 struct SfcrC *o,*n;

 o= *objpt;
 if(o==NULL)
   return(0);
 for(;o->prev!=NULL;o= o->prev);
 for(;o!=NULL;o= n) {
   n= o->next;
   Sfcrc_destroy(&o,0);
 }
 *objpt= NULL;
 return(1);
}


int Sfcrc_get_name(o,pt,flag)
struct SfcrC *o;
char **pt;
int flag;
{
 *pt= o->name;
 return(1);
}


int Sfcrc_get_style(o,pt,flag)
struct SfcrC *o;
int *pt;
int flag;
{
 *pt= o->style;
 return(1);
}


int Sfcrc_get_in_data(o,pt,flag)
struct SfcrC *o;
char **pt;
int flag;
{
 *pt= o->in_data;
 return(1);
}


int Sfcrc_get_in_data_len(o,pt,flag)
struct SfcrC *o;
int *pt;
int flag;
{
 *pt= o->in_data_len;
 return(1);
}


int Sfcrc_get_size(o,pt,flag)
struct SfcrC *o;
double *pt;
int flag;
{
 *pt= o->size;
 return(1);
}


int Sfcrc_get_crc32(o,pt,flag)
struct SfcrC *o;
unsigned long *pt;
int flag;
{
 *pt= o->crc32;
 return(1);
}


int Sfcrc_get_prev(o,pt,flag)
struct SfcrC *o;
struct SfcrC **pt;
int flag;
{
 *pt= o->prev;
 return(1);
}


int Sfcrc_get_next(o,pt,flag)
struct SfcrC *o;
struct SfcrC **pt;
int flag;
{
 *pt= o->next;
 return(1);
}


int Sfcrc_link(o,link,flag)
struct SfcrC *o;
struct SfcrC *link;
int flag;
/*
  bit0= insert as link->prev rather than as link->next
*/
{
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;
 o->prev= o->next= NULL;
 if(link==NULL)
   return(1);
 if(flag&1) {
   o->next= link;
   o->prev= link->prev;
   if(o->prev!=NULL)
     o->prev->next= o;
   link->prev= o;
 } else {
   o->prev= link;
   o->next= link->next;
   if(o->next!=NULL)
     o->next->prev= o;
   link->next= o;
 }
 return(1);
}


int Sfcrc_count(liststart,flag)
struct SfcrC *liststart;
int flag;
{
 struct SfcrC *o;
 int count= 0;

 for(o= liststart;o!=NULL;o= o->next) {
   if(o->style<0)
 continue;
   count++;
 }
 return(count);
}


int Sfcrc_copy(from,to,flag)
struct SfcrC *from,*to;
int flag;
{
 int l,i;

 if(from==NULL || to==NULL)
   return(0);
 if(Sregex_string(&(to->name),from->name,0)<=0)
   return(-1);
 to->style= from->style;
 Sregex_string(&(to->in_data),NULL,0);
 l= from->in_data_len;
 if(l<=0)
   l= 1;
 to->in_data= TSOB_FELD(char,l);
 for(i=0;i<from->in_data_len;i++)
   to->in_data[i]= from->in_data[i];
 to->in_data_len= from->in_data_len;
 to->size= from->size;
 to->crc32= from->crc32;
 return(1);
}


int Sfcrc_link_copy(from,link,flag)
struct SfcrC *from,*link;
int flag;
/*
  bit0= insert as link->prev rather than as link->next
*/
{
 int ret;
 struct SfcrC *o;

 ret= Sfcrc_new(&o,NULL,0,0);
 if(ret<=0)
   return(ret);
 ret= Sfcrc_copy(from,o,0);
 if(ret<=0)
   return(ret);
 Sfcrc_link(o,link,flag&1);
 return(1);
}


int Sfcrc_copy_all(from,to,flag)
struct SfcrC *from,*to;
int flag;
{
 int ret;
 struct SfcrC *o;

 for(o= from;o!=NULL; o= o->next) {
   if(o->style<0)
 continue;
   ret= Sfcrc_link_copy(o,to,0);
   if(ret<=0)
     return(ret);
 }
 return(1);
}


int Sfcrc__split_csv_line(line,cpt,flag)
char *line;
char *cpt[4];  /* pointing to end zeros of : name,size,crc,comment */
int flag;
{
 int i;
 char *rpt;

 rpt= line;
 for(i=0;i<4;i++) 
   cpt[i]= 0;
 for(i=0;i<4;i++) {
   cpt[i]= strchr(rpt,',');
   if(cpt[i]==NULL) {
     if(i<3)
       return(0);
     return(2);
   }
   rpt= cpt[i]+1;
   *(cpt[i])= 0;
 }
 return(1);
}


int Sfcrc_decode_csv(o,line,flag)
struct SfcrC *o;
char *line;
int flag;
{
 int ret,i;
 char *cpt[4],*rpt;
 struct SfcrC *objpt= NULL;

 ret= Sfcrc_new(&objpt,line,strlen(line)+1,0);
 if(ret<=0)
   return(ret);
 objpt->style= 1;

 ret= Sfcrc__split_csv_line(line,cpt,0);
 if(ret<=0)
   goto ex;
 if(Sregex_string(&(objpt->name),line,0)<=0)
   {ret= -1; goto ex;}
 objpt->size= -1.0;
 sscanf(cpt[0]+1,"%lf",&(objpt->size));
 if(objpt->size==-1.0)
   {ret= 0; goto ex;}
 for(rpt= cpt[1]+1;rpt<cpt[1]+9;rpt++)
   if((*rpt<'0'||*rpt>'9') && (*rpt<'A'||*rpt>'F') && (*rpt<'a'||*rpt>'f'))
     {ret= 0; goto ex;}
 sscanf(cpt[1]+1,"%X",&(objpt->crc32));
 ret= 1;
ex:;
 strcpy(line,objpt->in_data);
 if(ret<=0) {
   Sfcrc_destroy(&objpt,0);
 } else {
   Sfcrc_link(objpt,o,0);
 } 
 return(ret);
}


int Sfcrc_decode_sfv(o,line,flag)
struct SfcrC *o;
char *line;
int flag;
/* return:  <=0 =failed , 1 = success , 2 = remark ignored */
{
 int ret;
 char *cpt,*rpt;
 struct SfcrC *objpt= NULL;

 if(line[0]==';')
   return(2);                               /* remarks are ignored up to now */
 ret= Sfcrc_new(&objpt,line,strlen(line)+1,0);
 if(ret<=0)
   return(ret);
 objpt->style= 2;

 cpt= strrchr(line,' ');
 if(cpt==NULL || cpt==line)
   {ret= 0; goto ex;}
 *cpt= 0;
 if(Sregex_string(&(objpt->name),line,0)<=0)
   {ret= -1; goto ex;}
 if(strlen(cpt+1)<8)
   {ret= 0; goto ex;}
 for(rpt= cpt+1;rpt<cpt+9;rpt++)
   if((*rpt<'0'||*rpt>'9') && (*rpt<'A'||*rpt>'F') &&
     (*rpt<'a'||*rpt>'f') )
       {ret= 0; goto ex;}
 sscanf(cpt+1,"%X",&(objpt->crc32));
 ret= 1;
ex:;
 strcpy(line,objpt->in_data);
 if(ret<=0) {
   Sfcrc_destroy(&objpt,0);
 } else {
   Sfcrc_link(objpt,o,0);
 } 
 return(ret);
}


int Sfcrc_decode_smp16(o,line,flag)
struct SfcrC *o;
char *line;
int flag;
/* return:  <=0 =failed , 1 = success , 2 = crc invalid */
{
 int ret;
 char *cpt,*rpt;
 struct SfcrC *objpt= NULL;
 unsigned long flags= 7;

 if(strlen(line)<35)
   return(0);
 ret= Sfcrc_new(&objpt,line,strlen(line)+1,0);
 if(ret<=0)
   return(ret);
 objpt->style= 3;

 if(strncmp(line,"-smp16-",7)!=0)
   {ret= 0; goto ex;}
 line[15]= 0;
 sscanf(line+7,"%X",&flags);
 if(flags&4)
   {ret= 2; goto ex;}
 cpt= line+24;
 for(rpt= cpt+1;rpt<cpt+9;rpt++)
   if((*rpt<'0'||*rpt>'9') && (*rpt<'A'||*rpt>'F') &&
     (*rpt<'a'||*rpt>'f') )
       {ret= 0; goto ex;}
 line[33]= 0;
 sscanf(cpt+1,"%X",&(objpt->crc32));
 cpt= strchr(line+34,'+');
 if(cpt==NULL)
   {ret= 0; goto ex;}
 if(Sregex_string(&(objpt->name),cpt,0)<=0)
   {ret= -1; goto ex;}
 ret= 1;
ex:;
 strcpy(line,objpt->in_data);
 if(ret!=1) {
   Sfcrc_destroy(&objpt,0);
 } else {
   Sfcrc_link(objpt,o,0);
 } 
 return(ret);
}


int Sfcrc_read_list(o,listadr,line_count,flag)
struct SfcrC *o;
char *listadr;
int *line_count;
int flag;
{
 int style= 0,ret;
 char line[SfileadrL],*cpt,*ncpt,*rpt;
 FILE *fp= NULL;

 *line_count= 0;
 fp= Sfile_fopen(listadr,"r",0);
 if(fp==NULL)
   {ret= 0; goto ex;}
 while(Sfile_fgets(line,sizeof(line)-1,fp)!=NULL) {
   if(line[0]==0)
 continue;
   if(style==0) {
                                                         /* determine style */
     if(strncmp(line,"-smp16-",7)==0 && strlen(line)>226)
       style= 3;
     if(style==0) {
                                                         /* Is this a CSV ? */
       cpt= line;
       cpt= strchr(cpt,',');                              /* skip file name */
       if(cpt==NULL) 
         goto no_csv;
       ncpt= strchr(cpt+1,',');           /* check field for decimal length */
       if(ncpt==NULL) 
         goto no_csv;
       for(rpt= cpt+1;rpt<ncpt;rpt++)
         if(*rpt<'0'||*rpt>'9')
           goto no_csv;
       cpt= ncpt;                            /* check field for hex CRC-32 */
       ncpt= strchr(cpt+1,',');
       if(ncpt==NULL) 
         goto no_csv;
       if(ncpt-cpt!=9)
         goto no_csv;
       for(rpt= cpt+1;rpt<ncpt;rpt++)
         if((*rpt<'0'||*rpt>'9') && (*rpt<'A'||*rpt>'F') &&
            (*rpt<'a'||*rpt>'f') )
           goto no_csv;
       style= 1;
     }
no_csv:;
     if(style==0) {
                                                       /* Is this a SFV ? */
       cpt= strrchr(line,' ');
       if(cpt==NULL || cpt==line)
         goto no_sfv;
       if(strlen(cpt)<9)
         goto no_sfv;
       for(rpt= cpt+1;rpt<cpt+9;rpt++)
         if((*rpt<'0'||*rpt>'9') && (*rpt<'A'||*rpt>'F') &&
            (*rpt<'a'||*rpt>'f') )
           goto no_sfv;
       style= 2;
     }
no_sfv:;
   }
   if(style==0) 
 continue;
   if(style==1) {
     ret= Sfcrc_decode_csv(o,line,0);
   } else if(style==2) {
     ret= Sfcrc_decode_sfv(o,line,0);
   } else if(style==3) {
     ret= Sfcrc_decode_smp16(o,line,0);
   }
   if(ret<=0)
     goto ex;
   (*line_count)++;
 }
 ret= 1;
ex:;
 if(fp!=NULL)
   Sfile_fclose(fp);
 return(ret);
}


int Sfcrc_write_list(liststart,listadr,line_count,flag)
struct SfcrC *liststart;
char *listadr;
int *line_count;
int flag;
/*
 bit0-7: style (see SfcrC.style in sfcrc.h)
*/
{
 int style,ret;
 char line[SfileadrL],comment[SfileadrL],*cpt[4];
 FILE *fp= NULL;
 struct SfcrC *o;

 style= flag&255;

 *line_count= 0;
 fp= Sfile_fopen(listadr,"w",2);
 if(fp==NULL)
   {ret= 0; goto ex;}
 if(style==2) { /* SFV comment header */
   sprintf(line,"; Generated by SfcrC , %s\r\n",Sfile_datestr(time(0),256|1));
   ret= Sfile_write(fileno(fp),line,strlen(line),0,1);
   if(ret<=0)
     goto ex;
 }
 /* Lists are linked reversely. Search end and read backwards */
 for(o= liststart;o->next!=NULL;o= o->next) ;
 for(;o!=NULL;o= o->prev) {
   if(o->style<0)
 continue;
   if(style==1) { /* CSV :   name,size,crc,comment, */
     strcpy(comment,"\\ \\");
     /* try to obtain CSV comment from in_data */;
     if(o->style==1 && o->in_data_len<sizeof(line)) {
       strcpy(line,o->in_data);
       ret= Sfcrc__split_csv_line(line,cpt,0);
       if(ret<=0)
         goto ex;
       strcpy(comment,cpt[2]+1);
     }
     sprintf(line,"%s,%.lf,%-8.8X,%s,\r\n",o->name,o->size,o->crc32,comment);
   } else if(style==2) { /* SFV : name crc */
     sprintf(line,"%s %-8.8X\r\n",o->name,o->crc32);
   } else {
     ret= 0; goto ex;
   }
   ret= Sfile_write(fileno(fp),line,strlen(line),0,1);
   if(ret<=0)
     goto ex;
   (*line_count)++;
 }
 ret= 1;
ex:;
 if(fp!=NULL)
   Sfile_fclose(fp);
 return(ret);
}


int Sfcrc__file_par(fileadr,size,crc32,flag)
char *fileadr;
double *size;
unsigned long *crc32;
int flag;
{
 int ret,count;
 char buf[8192];
 FILE *fp= NULL;
 
 *size= -1.0;
 fp= Sfile_fopen(fileadr,"r",0);
 if(fp==NULL)
   {ret= 0; goto ex;}
 Sregex_crc32_yenc(buf,0,crc32,1);                                  /* init */
 *size= 0.0;
 while(1) {
   ret= Sfile_read(fileno(fp),buf,sizeof(buf),&count,0);
   if(ret<0)
     goto ex;
   if(ret==0 || count==0)
 break;
   (*size)+= count;
   ret= Sregex_crc32_yenc(buf,count,crc32,0);
   if(ret<=0)
     goto ex;
 }
 ret= 1;
ex:;
 if(fp!=NULL)
   Sfile_fclose(fp);
 return(ret);
}


int Sfcrc_new_from_filedata(objpt,link,fileadr,flag)
struct SfcrC **objpt;
struct SfcrC *link;
char *fileadr;
int flag;
/*
  bit0= insert as link->prev rather than as link->next
  bit1= register only basename of fileadr
*/
{
 char *cpt,addon[84];
 struct SfcrC *o= NULL;
 int ret;

 *objpt= NULL;
 ret= Sfcrc_new(&o,NULL,0,0);
 if(ret<=0)
   goto ex;
 cpt= fileadr;
 if(flag&2) {
   cpt= strrchr(fileadr,'/');
   if(cpt==NULL)
     cpt= fileadr;
   else
     cpt++;
 }
 if(Sregex_string(&(o->name),cpt,NULL)<=0)
   {ret=  -1; goto ex;}
 ret= Sfcrc__file_par(fileadr,&(o->size),&(o->crc32),0);
 if(ret<=0)
   goto ex;
 sprintf(addon," %.lf %X",o->size,o->crc32);
 if(Sregex_string(&(o->in_data),fileadr,0)<=0)
   {ret=  -1; goto ex;}
 if(Sregex_string(&(o->in_data),addon,1)<=0)
   {ret=  -1; goto ex;}
 o->in_data_len= strlen(o->in_data)+1;
 ret= 1;
ex:;
 if(ret<=0) {
   Sfcrc_destroy(&o,0);
 } else {
   Sfcrc_link(o,link,flag&1);
   *objpt= o;
 }
 return(ret);
}


int Sfcrc_search(liststart,wanted,found,flag)
struct SfcrC *liststart,*wanted,**found;
int flag;
/*
 bit0= start a new search at liststart (also if *found==NULL)
 bit1= check for name mismatch
*/
/*
 return: <0=error , 0=not found , 1=found , 2=name mismatch
*/
{
 int ret,i;
 struct SfcrC *o;

 if(wanted->style<0)
   {ret= 0; goto ex;}
 if((flag&1) || *found==NULL)
   o= liststart;
 else
   o= (*found)->next;
 *found= NULL;
 for(;o!=NULL;o= o->next) {
   if(o->style<0)
 continue;
   if(o->crc32==wanted->crc32)
     if(o->size<=0 || wanted->size<=0 || o->size==wanted->size) {
       *found= o;
       ret= 1; goto ex;
     }
 }
 ret= 0;
ex:;
 if(ret>0 && *found!=NULL && (flag&2)) {
   if(wanted->name!=NULL && (*found)->name!=NULL) {
     if(strlen(wanted->name)!=strlen((*found)->name)) {
       ret= 2;
     } else {
       for(i= strlen(wanted->name)-1;i>=0;i--)
         if(tolower(wanted->name[i])!=tolower((*found)->name[i]))
       break;
       if(i>=0)
         ret= 2;
     }
   }
 }
 return(ret); 
}


int Sfcrc_compare_crc(f1,f2)
struct SfcrC **f1,**f2;
{
 if((*f1)->crc32<(*f2)->crc32)
   return(-1);
 if((*f1)->crc32>(*f2)->crc32)
   return(1);
 if((*f1)->size<(*f2)->size)
   return(-1);
 if((*f1)->size>(*f2)->size)
   return(1);
 return(0);
}


int Sfcrc_compare_name(f1,f2)
struct SfcrC **f1,**f2;
{
 return(strcmp((*f1)->name,(*f2)->name));
}


int Sfcrc_compare_size(f1,f2)
struct SfcrC **f1,**f2;
{
 if((*f1)->size<(*f2)->size)
   return(-1);
 if((*f1)->size>(*f2)->size)
   return(1);
 return(0);
}


int Sfcrc_compare_comment(f1,f2)
struct SfcrC **f1,**f2;
{
 int i;
 char *cpt1,*cpt2;
 
 cpt1= (*f1)->in_data;
 cpt2= (*f2)->in_data;
 for(i=0;cpt1!= NULL && i<3;i++) {
   cpt1= strchr(cpt1,',');
   if(cpt1!=NULL)
     cpt1++;
 }
 for(i=0;cpt2!= NULL && i<3;i++) {
   cpt2= strchr(cpt2,',');
   if(cpt2!=NULL)
     cpt2++;
 }
 if(cpt1==cpt2)
   return(0);
 if(cpt1==NULL)
   return(-1);
 if(cpt2==NULL)
   return(1);
 return(strcmp(cpt1,cpt2));
}


int Sfcrc_create_sorted_pt(liststart,pt_io,pt_z,Sfcrc_compare,flag)
struct SfcrC *liststart;
int (*Sfcrc_compare)();
struct SfcrC ***pt_io;
int *pt_z;
int flag;
{
 struct SfcrC *o;
 int i,ret,count= 0;

 *pt_io= NULL;
 count= Sfcrc_count(liststart,0);
 *pt_io= TSOB_FELD(struct SfcrC *,count+1);
 if(*pt_io==NULL)
   {ret= -1; goto ex;}
 i= 0;
 for(o= liststart;o!=NULL;o= o->next) {
   if(o->style<0)
 continue;
   if(i>=count)
 break;
   (*pt_io)[i]= o;
   i++;
 }
 count= i;
 if(count>0)
   qsort(*pt_io,count,sizeof(struct SfcrC *),Sfcrc_compare);
 *pt_z= count;
 ret= 1;
ex:;
 if(ret<=0) {
   if(*pt_io!=NULL)
     Smem_freE((char *) *pt_io);
   *pt_io= NULL;
 }
 return(ret);
}


int Sfcrc_cross_search(liststart1,liststart2,pt1_io,pt2_io,pt1_z,pt2_z,
                         found1,found2,flag)
struct SfcrC *liststart1,*liststart2;
struct SfcrC ***pt1_io,***pt2_io;
int *pt1_z,*pt2_z;
int *found1,*found2;
int flag;
/*
 bit0= start a new search at liststart (also if *found?==-1)
       free pt?_io if not NULL
 bit15= free pt?_io
*/
/*
 return: <0=error , 0=nothing found , 1=found
*/
{
 int ret,comp;
 int r1,r2;
 struct SfcrC **pt1,**pt2;

 pt1= *pt1_io;
 pt2= *pt2_io;
 if(flag&(1<<15))
   flag|= 1;
 if((flag&1) || *found1==-1 || *found2==-1) {
   r1= 0;
   r2= 0;
   if((*pt1_io)!=NULL)
     Smem_freE((char *) *pt1_io);
   *pt1_io= NULL;
   if((*pt2_io)!=NULL)
     Smem_freE((char *) *pt2_io);
   *pt2_io= NULL;
   if(flag&(1<<15))
     {ret= 1; goto ex;}
   ret= Sfcrc_create_sorted_pt(liststart1,pt1_io,pt1_z,Sfcrc_compare_crc,0);
   if(ret<=0)
     {ret= -1; goto ex;}
   ret= Sfcrc_create_sorted_pt(liststart2,pt2_io,pt2_z,Sfcrc_compare_crc,0);
   if(ret<=0)
     {ret= -1; goto ex;}
   pt1= *pt1_io;
   pt2= *pt2_io;
 } else {
   r1= *found1;
   r2= (*found2)+1;
   if(r2>=*pt2_z) {
advance_r1:;
     r1++;
     if(r1>=*pt1_z)
       {ret= 0; goto ex;}
     /* search the first item in pt2 which is equal to pt1[r1]
        (if ever, these items must be at the very end of pt2 ) */
     for(;r2>0;r2--)
       if(Sfcrc_compare_crc(&pt1[r1],&pt2[r2-1])!=0)
     break;
     if(r2>=*pt2_z)             /* no remaining equals found, search done */
       {ret= 0; goto ex;}
   }
 }

 while(r1<*pt1_z && r2<*pt2_z) {
   comp= Sfcrc_compare_crc(&pt1[r1],&pt2[r2]);
   if(comp==0) {
     *found1= r1;
     *found2= r2;
     ret= 1; goto ex;
   } else if(comp>0) {
     r2++;
   } else 
     goto advance_r1;
 }

 ret= 0;
ex:;
/*
 if(ret<=0)
   *found1= *found2= -1;
*/
 return(ret);
}


