
#ifndef Shash_includeD
#define Shash_includeD



/* MD5 :
   This code is derived from RFC 1321 and implements computation of the
    "RSA Data Security, Inc. MD5 Message-Digest Algorithm" */

/* MD5 context */
struct Shash_md5_ctX {
  unsigned long state[4];                                   /* state (ABCD) */
  unsigned long count[2];        /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];                                 /* input buffer */
};

/* MD5 constants */
#define Shash_md5_S11 7
#define Shash_md5_S12 12
#define Shash_md5_S13 17
#define Shash_md5_S14 22
#define Shash_md5_S21 5
#define Shash_md5_S22 9
#define Shash_md5_S23 14
#define Shash_md5_S24 20
#define Shash_md5_S31 4
#define Shash_md5_S32 11
#define Shash_md5_S33 16
#define Shash_md5_S34 23
#define Shash_md5_S41 6
#define Shash_md5_S42 10
#define Shash_md5_S43 15
#define Shash_md5_S44 21

/* end MD5 */


/* SHA-1 :
   derived from code found at http://4049.nwr.jp/comp/sha1.html
   see shash.c "SHA-1" for the copyright and license statement */

typedef unsigned int    Shash_sha1_worD;    /* 32bits unsigned integer */
typedef unsigned char   Shash_sha1_bytE;    /* 8bits unsigned integer */

/* Define the state of SHA-1 algorithm */
struct Shash_sha1_ctX {
  Shash_sha1_bytE   sha1_buf[64];   /* 512 bits */
  int               sha1_count;     /* How many bytes are used */
  Shash_sha1_worD   sha1_size1;     /* Length counter Lower Word */
  Shash_sha1_worD   sha1_size2;     /* Length counter Upper Word */
  Shash_sha1_worD   sha1_h[5];      /* Hash output */
};

#define Shash_sha1_bitS               8
#define Shash_sha1_output_sizE        20      /* in bytes */
#define Shash_sha1_inlinE         inline

#define Shash_sha1_k0           0x5a827999
#define Shash_sha1_k1           0x6ed9eba1
#define Shash_sha1_k2           0x8f1bbcdc
#define Shash_sha1_k3           0xca62c1d6


/* end SHA-1 */

#endif /* ! Shash_includeD */
