
/*
in src/stic_build :
 cc -g -o smtps -DSmtpsend_own_maiN ../smtp/smtpsend.c \
    stcp.o sfile.o sregex.o smem.o
*/

#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include <time.h>

#include <sys/socket.h>
#define closesocket close

#include "../s_tools/smem.h"
#include "../s_tools/sregex.h"
#include "../s_tools/sfile.h"

#include "smtpsend.h"


int Smtpsend_new(sender,target_host,from,to,subject,body,flag)
struct SmtpsenD **sender;
char *target_host;
char *from;
char *to;
char *subject;
char *body;
int flag;
/*
 bit0= body is a filename where to find the body
*/
{
 struct SmtpsenD *c;
 int ret;

 *sender= c= TSOB_FELD(struct SmtpsenD,1);
 if(c==NULL)
   return(-1);
 c->target_host= NULL;
 c->port= 25;
 c->fd= -1;
 c->from= NULL;
 c->to= NULL;
 c->subject= NULL;
 c->body_text= NULL;
 c->body_filename= NULL;
 c->errmsg= NULL;

 if(Sregex_string(&(c->target_host),target_host,0)<=0)
   goto failed;
 if(Sregex_string(&(c->from),from,0)<=0)
   goto failed;
 if(Lstring_new(&(c->to),to,NULL,0)<=0)
   goto failed;
 if(Sregex_string(&(c->subject),subject,0)<=0)
   goto failed;
 if(flag&1) {
   if(Sregex_string(&(c->body_filename),body,0)<=0)
     goto failed;
 } else {
   if(Sregex_string(&(c->body_text),body,0)<=0)
     goto failed;
 }
 if(Sregex_string(&(c->errmsg),"",0)<=0)
   goto failed;
 return(1);
failed:;
 Smtpsend_destroy(sender,0);
 return(-1);
}


int Smtpsend_destroy(sender,flag)
struct SmtpsenD **sender;
int flag;
{
 struct SmtpsenD *c;

 c= *sender;
 if(c==NULL)
   return(0);
 
 Sregex_string(&(c->target_host),NULL,0);
 Sregex_string(&(c->from),NULL,0);
 Lstring_destroy_all(&(c->to),0);
 Sregex_string(&(c->subject),NULL,0);
 Sregex_string(&(c->body_filename),NULL,0);
 Sregex_string(&(c->body_text),NULL,0);
 Sregex_string(&(c->errmsg),NULL,0);
 *sender= NULL;
 return(0);
}


int Smtpsend_get_errmsg(sender,errmsg,flag)
struct SmtpsenD *sender;
char **errmsg;
int flag;
{
 *errmsg= sender->errmsg;
 return(1);
}


int Smtpsend_add_to(sender,to,flag)
struct SmtpsenD *sender;
char *to;
int flag;
{
 if(Lstring_append(sender->to,to,0)<=0)
   return(-1);
 return(1);
}


int Smtpsend_format_date(sender,datestr,flag)
struct SmtpsenD *sender;
char datestr[80];
int flag;
/*
 bit0= format as UTC (GMT)
*/
{
 char* weekdays[7]= {"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
 char* months[12]= {"Jan","Feb","Mar","Apr","May","Jun",
                    "Jul","Aug","Sep","Oct","Nov","Dec"};
 int t, tzbias=0;
 time_t now, localtimet, gmtimet;
 struct tm tm, *ltm, gm_tm;
 double diff;

 time(&now);
 if (flag&1)
   tm=*gmtime(&now);
 else {
   localtimet=mktime(ltm=localtime(&now));
   memcpy(&tm,ltm,sizeof(struct tm));
 
   ltm= gmtime(&now); /* ltm would not survive a xyztime() call */
   /* overwrite all undocumented tm fields by localtime values */
   memcpy(&gm_tm,&tm,sizeof(struct tm));
   /* copy the documented tm fields which describe the time */
   gm_tm.tm_sec= ltm->tm_sec;
   gm_tm.tm_min= ltm->tm_min;
   gm_tm.tm_hour= ltm->tm_hour;
   gm_tm.tm_mday= ltm->tm_mday;
   gm_tm.tm_mon= ltm->tm_mon;
   gm_tm.tm_year= ltm->tm_year;
   gm_tm.tm_wday= ltm->tm_wday;
   gm_tm.tm_yday= ltm->tm_yday;
   gmtimet= mktime(&gm_tm);
   diff= difftime(localtimet, gmtimet);
   tzbias= (int)(diff/60);
 }
 t= tzbias/60;
 tzbias= (t*100)+(tzbias%60);
 sprintf(datestr, "%s, %02d %s %04d %02d:%02d:%02d %+05d",
                  weekdays[tm.tm_wday], tm.tm_mday,
                  months[tm.tm_mon], tm.tm_year + 1900,
                  tm.tm_hour, tm.tm_min, 
                  tm.tm_sec, tzbias);
 return(1);
}


int Smtpsend_read_reply(sender,rcode,flag)
struct SmtpsenD *sender;
int *rcode;
int flag;
/*
 bit0= do not wait for reply
*/
{
 int ret,count,expect_more,replysize= 8192,i;
 unsigned char reply[8192],*rpt,*wpt,*crlfpt;
 
 reply[0]= 0;
read_reply:; 
 while(strstr(reply,"\r\n")==NULL) {
   ret= Stcpfd_read(sender->fd,reply,replysize-strlen(reply)-1,&count,0);
   if(ret<=0) {
read_failed:;
     if(Sregex_string(&(sender->errmsg),"read failed : ",0)<=0)
       {ret= -1; goto ex;}
     if(errno>0) {
       if(Sregex_string(&(sender->errmsg),strerror(errno),1)<=0)
         {ret= -1; goto ex;}
     } else {
       if(Sregex_string(&(sender->errmsg),"premature end of connection",1)<=0)
         {ret= -1; goto ex;}
     }
     goto ex;
   }
 }
process_reply:;
 crlfpt= strstr(reply,"\r\n");
 (*crlfpt)= 0;
 printf("< ");
 for(i=0;reply[i]!=0;i++) {
   if((reply[i]<32 || reply[i]>127 || reply[i]=='\\') && reply[i]!='\n')
     printf("\\%-2.2X",reply[i]);
   else
     printf("%c",reply[i]);
 }
 printf("\n");
 (*crlfpt)= '\r';

 if(strlen(reply)<4) 
   goto read_failed;
 expect_more= (reply[3]=='-');

 /* determine replycode */
 reply[3]= 0;
 sscanf(reply,"%ld",rcode);

 if(expect_more) {
   /* shift to remove first CRLF */
   wpt= reply;
   for(rpt= strstr(reply,"\r\n")+2;(*rpt)!=0;rpt++)
     *(wpt++)= *rpt;
   (*wpt)= 0;
   if(strstr(reply,"\r\n")!=NULL)
     goto process_reply;
   goto read_reply; 
 }

 ret= 1;
ex:;
 return(ret);
}


int Smtpsend_say(sender,cmd,param,expected,rcode,flag)
struct SmtpsenD *sender;
char *cmd;
char *param;
int expected;
int *rcode;
int flag;
/*
 bit0= do not wait for reply
 bit1= write " " between cmd and param
*/
{
 int ret,replycode;
 char line[160];

 printf("> %s",cmd); 
 ret= Stcpfd_write(sender->fd,cmd,strlen(cmd),0);
 if(ret<=0) {
write_failed:;
   if(Sregex_string(&(sender->errmsg),"write failed : ",0)<=0)
     {ret= -1; goto ex;}
   if(Sregex_string(&(sender->errmsg),strerror(errno),1)<=0)
     {ret= -1; goto ex;}
   goto ex;
 }
 if(param[0]) {
   if(flag&2) {
     printf(" ");
     ret= Stcpfd_write(sender->fd," ",1,0);
     if(ret<=0)
       goto write_failed;
   }
   printf("%s",param); 
   ret= Stcpfd_write(sender->fd,param,strlen(param),0);
   if(ret<=0) 
     goto write_failed;
 }
 printf("\n"); 
 ret= Stcpfd_write(sender->fd,"\r\n",2,0);
 if(ret<=0) 
   goto write_failed;

 if(flag&1)
   {ret= 1; goto ex;}

 /* read reply */
 ret= Smtpsend_read_reply(sender,&replycode,0);
 if(ret<=0)
   goto ex;
 *rcode= replycode;
 if(replycode!=expected) {
   if(Sregex_string(&(sender->errmsg),"reply code mismatch : ",0)<=0)
     {ret= -1; goto ex;}
   sprintf(line,"cmd='%s'  reply=%ld (expected %ld)",cmd,replycode,expected);
   if(Sregex_string(&(sender->errmsg),line,1)<=0)
     {ret= -1; goto ex;}
   ret= 0; goto ex;
 }
 ret= 1;
ex:;
 return(ret);
}


int Smtpsend_body(sender,flag)
struct SmtpsenD *sender;
int flag;
{
 int ret,lineend=0,i,o= 0,l,more_to_do= 0,count,fd;
 char line[1024],*msg,buf[4096];
 FILE *fp= NULL;

 /* send the body line by line, enforcing SMTP rules:
        - no line may be longer than 1000 characters
        - line breaks are <CR><LF>
        - dots at line beginnings are doubled
 */

 if(sender->body_text!=NULL) {
   msg= sender->body_text;
 } else {
   fp= Sfile_fopen(sender->body_filename,"r",1);
   if(fp==NULL) {
     if(Sregex_string(&(sender->errmsg),"cannot open file : ",0)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&(sender->errmsg),sender->body_filename,1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&(sender->errmsg),"\n",1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&(sender->errmsg),strerror(errno),1)<=0)
       {ret= -1; goto ex;}
     ret= 0; goto ex;
   }
   fd= fileno(fp);
   msg= buf;
   buf[0]= 0;
   more_to_do= 1;
 } 

do_more:;
 if(fp!=NULL) {
   ret= Sfile_read(fd,buf,sizeof(buf)-1,&count,0);
   if(ret<0) {
     if(Sregex_string(&(sender->errmsg),"error while reading file : ",0)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&(sender->errmsg),sender->body_filename,1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&(sender->errmsg),"\n",1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&(sender->errmsg),strerror(errno),1)<=0)
       {ret= -1; goto ex;}
     ret= 0; goto ex;
   }  
   if(ret==0) {
     if(o>0) {
       line[o++]='\r'; line[o++]='\n';
       ret= Stcpfd_write(sender->fd,line,o,0);
       if(ret<=0) 
         goto write_failed;
     }
     ret= 1;
     goto ex;
   }
   buf[count]= 0;
 }

 l= strlen(msg);
 for (i=0; i<l; i++) {
   lineend= 0;
   switch(msg[i]) {
   case '\r': /* do nothing */
     break;
   case '\n':
     lineend=1;
     break;
   case '.':
     if (o==0) line[o++]='.'; 
     /* and continue with default case */
   default:
     line[o]=msg[i];
     o++;
   }
   if (lineend || (o==1000-3) || (i==l-1 && !more_to_do)) {
     lineend=0;
     line[o++]='\r'; line[o++]='\n';
     ret= Stcpfd_write(sender->fd,line,o,0);
     if(ret<=0) {
write_failed:;
       if(Sregex_string(&(sender->errmsg),"write failed : ",0)<=0)
         {ret= -1; goto ex;}
       if(Sregex_string(&(sender->errmsg),strerror(errno),1)<=0)
         {ret= -1; goto ex;}
       goto ex;
     }
     o=0;
   }
 }

 if(more_to_do)
   goto do_more;

 ret= 1;
ex:;
 if(fp!=NULL)
   fclose(fp);
 return(ret);
}


int Smtpsend_data(sender,flag)
struct SmtpsenD *sender;
int flag;
{
 int ret,rcode;
 char datestr[80];

 ret= Smtpsend_say(sender,"DATA","",354,&rcode,0);
 if(ret<=0)
   goto ex;

 /* Prepend headers : Date From To Subject */
 printf("> ... headers ...\n");
 ret= Stcpfd_write(sender->fd,"Date: ",6,0);
 if(ret<=0) {
write_failed:;
   if(Sregex_string(&(sender->errmsg),"write failed : ",0)<=0)
     {ret= -1; goto ex;}
   if(Sregex_string(&(sender->errmsg),strerror(errno),1)<=0)
     {ret= -1; goto ex;}
   goto ex;
 }
 Smtpsend_format_date(sender,datestr,0);
 printf("> Date: %s\n",datestr);
 ret= Stcpfd_write(sender->fd,datestr,strlen(datestr),0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,"\r\n",2,0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,"From: ",6,0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,sender->from,strlen(sender->from),0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,"\r\n",2,0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,"To: ",4,0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,sender->to->text,strlen(sender->to->text),0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,"\r\n",2,0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,"Subject: ",9,0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,sender->subject,strlen(sender->subject),0);
 if(ret<=0) 
   goto write_failed;
 ret= Stcpfd_write(sender->fd,"\r\n",2,0);
 if(ret<=0) 
   goto write_failed;
 
 /* Send empty line */
 ret= Stcpfd_write(sender->fd,"\r\n",2,0);
 if(ret<=0) 
   goto write_failed;

 printf("> ... body ...\n");
 ret= Smtpsend_body(sender,0);
 if(ret<=0)
   goto ex;

 ret= Smtpsend_say(sender,".","",250,&rcode,0);
 if(ret<=0)
   goto ex;

 ret= 1;
ex:;
 return(ret);
}
 

int Smtpsend_deliver(sender,flag)
struct SmtpsenD *sender;
int flag;
{
 struct LstrinG *to;
 int ret,rcode,accepted= 0;
 char line[160],own_ip_adr[81];

 ret= Stcp_clientfd(&(sender->fd),sender->target_host,sender->port,0);
 if(ret<=0) {
   if(Sregex_string(&(sender->errmsg),"cannot connect to target host",0)<=0)
     {ret= -1; goto ex;}
   goto ex;
 }
 strcpy(own_ip_adr,"");
 ret= Stcp_client_get_hostadr(sender->fd,own_ip_adr,0);
 if(ret<=0)
   strcpy(own_ip_adr,"127.0.0.1");
 ret= Smtpsend_read_reply(sender,&rcode,0);
 if(ret<=0)
   goto ex;
 if(rcode!=220) {
   if(Sregex_string(&(sender->errmsg),"greeting code mismatch : ",0)<=0)
     {ret= -1; goto ex;}
   sprintf(line,"greeting=%ld (expected 220)",rcode);
   if(Sregex_string(&(sender->errmsg),line,1)<=0)
     {ret= -1; goto ex;}
   ret= 0; goto ex;
 }

 ret= Smtpsend_say(sender,"HELO",own_ip_adr,250,&rcode,2);
 if(ret<=0)
   goto ex;

 ret= Smtpsend_say(sender,"MAIL FROM:",sender->from,250,&rcode,0);
 if(ret<=0)
   goto ex;

 for(to= sender->to; to!=NULL; to= to->next) {
   ret= Smtpsend_say(sender,"RCPT TO:",to->text,250,&rcode,0);
   if(ret<0)
     goto ex;
   if(ret==0)
     if(rcode!=251 && rcode!=252) /* notification about forwarding attempt */
 continue;
   accepted++;
 }
 if(accepted==0) {
   if(Sregex_string(&(sender->errmsg),"Not a single recipient was accepted",0)
      <=0)
     {ret= -1; goto ex;}
   ret= 0;
   goto ex;
 }

 ret= Smtpsend_data(sender,0);
 if(ret<=0)
   goto ex;

 ret= Smtpsend_say(sender,"QUIT","",0,&rcode,1);
 if(ret<=0)
   goto ex;

 ret= 1;
ex:;
 if(sender->fd>=0)
   Stcpfd_close(sender->fd,0);
 sender->fd= -1;
 return(ret);
}


#ifdef Smtpsend_own_maiN

main(argc,argv)
int argc;
char **argv;
{
 int ret,body_is_file= 1,i;
 char *body,*errmsg;
 struct SmtpsenD *sender= NULL;

 if(argc<5) {
   fprintf(stderr, "usage : %s %s\n",argv[0],
      "target_host from to [... to] subject bodyfilename|\"-\"|\"=\"bodytext");
   fprintf(stderr, "A raw SMTP mail sender. The mail body may be read from\n");
   fprintf(stderr, "a file, from standard input by \"-\", or directly from\n");
   fprintf(stderr, "the last argument if it starts with \"=\".\n");
   fprintf(stderr, "The message is sent to port 25 at target_host where a\n");
   fprintf(stderr, "mail transfer agent should serve and take care of it.\n");
   exit(1);
 }
 body= argv[argc-1];
 if(body[0]=='=') {
   body_is_file= 0;
   body++;
 }
 ret= Smtpsend_new(&sender,argv[1],argv[2],argv[3],argv[argc-2],
                   body,body_is_file);
 if(ret<=0) {
err_creation:;
   fprintf(stderr,"%s : creation of mailer object failed\n",argv[0]);
   exit(2);
 }
 for(i=4;i<argc-2;i++) {
   ret= Smtpsend_add_to(sender,argv[i],0);
   if(ret<=0)
     goto err_creation;
 }
 ret= Smtpsend_deliver(sender,0);
 if(ret<=0) {
   fprintf(stderr,"%s : delivery of mail failed\n",argv[0]);
   Smtpsend_get_errmsg(sender,&errmsg,0);
   if(errmsg[0])
     fprintf(stderr,"( %s )\n",sender->errmsg);
   exit(3);
 }
 Smtpsend_destroy(&sender,0);
 exit(0);
}

#endif /* Smtpsend_own_maiN */

/*
Mail hosts:

 mail.gmx.net ...... needs POP3 authentication first
 smtp.t-online.de .. probably open because it is my ISP

*/
